/*
 * Copyright (C) 2017
 * Authors: Wen Wang <wen.wang.ww349@yale.edu>
 *          Ruben Niederhagen <ruben@polycephaly.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
*/

module gf_mul (
  input            clk,
  input  [12 : 0] dinA,
  input  [12 : 0] dinB,
  output [12 : 0] dout
);

  assign dout[0] = dinA[0]&dinB[0] ^ dinA[1]&dinB[12] ^ dinA[2]&dinB[11] ^ dinA[3]&dinB[10] ^ dinA[4]&dinB[9] ^ dinA[5]&dinB[8] ^ dinA[6]&dinB[7] ^ dinA[7]&dinB[6] ^ dinA[8]&dinB[5] ^ dinA[9]&dinB[4] ^ dinA[10]&dinB[3] ^ dinA[11]&dinB[2] ^ dinA[12]&dinB[1] ^ dinA[10]&dinB[12] ^ dinA[11]&dinB[11] ^ dinA[12]&dinB[10] ^ dinA[11]&dinB[12] ^ dinA[12]&dinB[11];
  assign dout[1] = dinA[0]&dinB[1] ^ dinA[1]&dinB[0] ^ dinA[1]&dinB[12] ^ dinA[2]&dinB[11] ^ dinA[3]&dinB[10] ^ dinA[4]&dinB[9] ^ dinA[5]&dinB[8] ^ dinA[6]&dinB[7] ^ dinA[7]&dinB[6] ^ dinA[8]&dinB[5] ^ dinA[9]&dinB[4] ^ dinA[10]&dinB[3] ^ dinA[11]&dinB[2] ^ dinA[12]&dinB[1] ^ dinA[2]&dinB[12] ^ dinA[3]&dinB[11] ^ dinA[4]&dinB[10] ^ dinA[5]&dinB[9] ^ dinA[6]&dinB[8] ^ dinA[7]&dinB[7] ^ dinA[8]&dinB[6] ^ dinA[9]&dinB[5] ^ dinA[10]&dinB[4] ^ dinA[11]&dinB[3] ^ dinA[12]&dinB[2] ^ dinA[10]&dinB[12] ^ dinA[11]&dinB[11] ^ dinA[12]&dinB[10] ^ dinA[12]&dinB[12];
  assign dout[2] = dinA[0]&dinB[2] ^ dinA[1]&dinB[1] ^ dinA[2]&dinB[0] ^ dinA[2]&dinB[12] ^ dinA[3]&dinB[11] ^ dinA[4]&dinB[10] ^ dinA[5]&dinB[9] ^ dinA[6]&dinB[8] ^ dinA[7]&dinB[7] ^ dinA[8]&dinB[6] ^ dinA[9]&dinB[5] ^ dinA[10]&dinB[4] ^ dinA[11]&dinB[3] ^ dinA[12]&dinB[2] ^ dinA[3]&dinB[12] ^ dinA[4]&dinB[11] ^ dinA[5]&dinB[10] ^ dinA[6]&dinB[9] ^ dinA[7]&dinB[8] ^ dinA[8]&dinB[7] ^ dinA[9]&dinB[6] ^ dinA[10]&dinB[5] ^ dinA[11]&dinB[4] ^ dinA[12]&dinB[3] ^ dinA[11]&dinB[12] ^ dinA[12]&dinB[11];
  assign dout[3] = dinA[0]&dinB[3] ^ dinA[1]&dinB[2] ^ dinA[2]&dinB[1] ^ dinA[3]&dinB[0] ^ dinA[1]&dinB[12] ^ dinA[2]&dinB[11] ^ dinA[3]&dinB[10] ^ dinA[4]&dinB[9] ^ dinA[5]&dinB[8] ^ dinA[6]&dinB[7] ^ dinA[7]&dinB[6] ^ dinA[8]&dinB[5] ^ dinA[9]&dinB[4] ^ dinA[10]&dinB[3] ^ dinA[11]&dinB[2] ^ dinA[12]&dinB[1] ^ dinA[3]&dinB[12] ^ dinA[4]&dinB[11] ^ dinA[5]&dinB[10] ^ dinA[6]&dinB[9] ^ dinA[7]&dinB[8] ^ dinA[8]&dinB[7] ^ dinA[9]&dinB[6] ^ dinA[10]&dinB[5] ^ dinA[11]&dinB[4] ^ dinA[12]&dinB[3] ^ dinA[4]&dinB[12] ^ dinA[5]&dinB[11] ^ dinA[6]&dinB[10] ^ dinA[7]&dinB[9] ^ dinA[8]&dinB[8] ^ dinA[9]&dinB[7] ^ dinA[10]&dinB[6] ^ dinA[11]&dinB[5] ^ dinA[12]&dinB[4] ^ dinA[10]&dinB[12] ^ dinA[11]&dinB[11] ^ dinA[12]&dinB[10] ^ dinA[11]&dinB[12] ^ dinA[12]&dinB[11] ^ dinA[12]&dinB[12];
  assign dout[4] = dinA[4]&dinB[12] ^ dinA[5]&dinB[11] ^ dinA[6]&dinB[10] ^ dinA[7]&dinB[9] ^ dinA[8]&dinB[8] ^ dinA[9]&dinB[7] ^ dinA[10]&dinB[6] ^ dinA[11]&dinB[5] ^ dinA[12]&dinB[4] ^ dinA[5]&dinB[12] ^ dinA[6]&dinB[11] ^ dinA[7]&dinB[10] ^ dinA[8]&dinB[9] ^ dinA[9]&dinB[8] ^ dinA[10]&dinB[7] ^ dinA[11]&dinB[6] ^ dinA[12]&dinB[5] ^ dinA[0]&dinB[4] ^ dinA[1]&dinB[3] ^ dinA[2]&dinB[2] ^ dinA[3]&dinB[1] ^ dinA[4]&dinB[0] ^ dinA[10]&dinB[12] ^ dinA[11]&dinB[11] ^ dinA[12]&dinB[10] ^ dinA[12]&dinB[12] ^ dinA[1]&dinB[12] ^ dinA[2]&dinB[11] ^ dinA[3]&dinB[10] ^ dinA[4]&dinB[9] ^ dinA[5]&dinB[8] ^ dinA[6]&dinB[7] ^ dinA[7]&dinB[6] ^ dinA[8]&dinB[5] ^ dinA[9]&dinB[4] ^ dinA[10]&dinB[3] ^ dinA[11]&dinB[2] ^ dinA[12]&dinB[1] ^ dinA[2]&dinB[12] ^ dinA[3]&dinB[11] ^ dinA[4]&dinB[10] ^ dinA[5]&dinB[9] ^ dinA[6]&dinB[8] ^ dinA[7]&dinB[7] ^ dinA[8]&dinB[6] ^ dinA[9]&dinB[5] ^ dinA[10]&dinB[4] ^ dinA[11]&dinB[3] ^ dinA[12]&dinB[2];
  assign dout[5] = dinA[5]&dinB[12] ^ dinA[6]&dinB[11] ^ dinA[7]&dinB[10] ^ dinA[8]&dinB[9] ^ dinA[9]&dinB[8] ^ dinA[10]&dinB[7] ^ dinA[11]&dinB[6] ^ dinA[12]&dinB[5] ^ dinA[6]&dinB[12] ^ dinA[7]&dinB[11] ^ dinA[8]&dinB[10] ^ dinA[9]&dinB[9] ^ dinA[10]&dinB[8] ^ dinA[11]&dinB[7] ^ dinA[12]&dinB[6] ^ dinA[0]&dinB[5] ^ dinA[1]&dinB[4] ^ dinA[2]&dinB[3] ^ dinA[3]&dinB[2] ^ dinA[4]&dinB[1] ^ dinA[5]&dinB[0] ^ dinA[11]&dinB[12] ^ dinA[12]&dinB[11] ^ dinA[2]&dinB[12] ^ dinA[3]&dinB[11] ^ dinA[4]&dinB[10] ^ dinA[5]&dinB[9] ^ dinA[6]&dinB[8] ^ dinA[7]&dinB[7] ^ dinA[8]&dinB[6] ^ dinA[9]&dinB[5] ^ dinA[10]&dinB[4] ^ dinA[11]&dinB[3] ^ dinA[12]&dinB[2] ^ dinA[3]&dinB[12] ^ dinA[4]&dinB[11] ^ dinA[5]&dinB[10] ^ dinA[6]&dinB[9] ^ dinA[7]&dinB[8] ^ dinA[8]&dinB[7] ^ dinA[9]&dinB[6] ^ dinA[10]&dinB[5] ^ dinA[11]&dinB[4] ^ dinA[12]&dinB[3];
  assign dout[6] = dinA[0]&dinB[6] ^ dinA[1]&dinB[5] ^ dinA[2]&dinB[4] ^ dinA[3]&dinB[3] ^ dinA[4]&dinB[2] ^ dinA[5]&dinB[1] ^ dinA[6]&dinB[0] ^ dinA[3]&dinB[12] ^ dinA[4]&dinB[11] ^ dinA[5]&dinB[10] ^ dinA[6]&dinB[9] ^ dinA[7]&dinB[8] ^ dinA[8]&dinB[7] ^ dinA[9]&dinB[6] ^ dinA[10]&dinB[5] ^ dinA[11]&dinB[4] ^ dinA[12]&dinB[3] ^ dinA[4]&dinB[12] ^ dinA[5]&dinB[11] ^ dinA[6]&dinB[10] ^ dinA[7]&dinB[9] ^ dinA[8]&dinB[8] ^ dinA[9]&dinB[7] ^ dinA[10]&dinB[6] ^ dinA[11]&dinB[5] ^ dinA[12]&dinB[4] ^ dinA[6]&dinB[12] ^ dinA[7]&dinB[11] ^ dinA[8]&dinB[10] ^ dinA[9]&dinB[9] ^ dinA[10]&dinB[8] ^ dinA[11]&dinB[7] ^ dinA[12]&dinB[6] ^ dinA[7]&dinB[12] ^ dinA[8]&dinB[11] ^ dinA[9]&dinB[10] ^ dinA[10]&dinB[9] ^ dinA[11]&dinB[8] ^ dinA[12]&dinB[7] ^ dinA[12]&dinB[12];
  assign dout[7] = dinA[0]&dinB[7] ^ dinA[1]&dinB[6] ^ dinA[2]&dinB[5] ^ dinA[3]&dinB[4] ^ dinA[4]&dinB[3] ^ dinA[5]&dinB[2] ^ dinA[6]&dinB[1] ^ dinA[7]&dinB[0] ^ dinA[4]&dinB[12] ^ dinA[5]&dinB[11] ^ dinA[6]&dinB[10] ^ dinA[7]&dinB[9] ^ dinA[8]&dinB[8] ^ dinA[9]&dinB[7] ^ dinA[10]&dinB[6] ^ dinA[11]&dinB[5] ^ dinA[12]&dinB[4] ^ dinA[5]&dinB[12] ^ dinA[6]&dinB[11] ^ dinA[7]&dinB[10] ^ dinA[8]&dinB[9] ^ dinA[9]&dinB[8] ^ dinA[10]&dinB[7] ^ dinA[11]&dinB[6] ^ dinA[12]&dinB[5] ^ dinA[7]&dinB[12] ^ dinA[8]&dinB[11] ^ dinA[9]&dinB[10] ^ dinA[10]&dinB[9] ^ dinA[11]&dinB[8] ^ dinA[12]&dinB[7] ^ dinA[8]&dinB[12] ^ dinA[9]&dinB[11] ^ dinA[10]&dinB[10] ^ dinA[11]&dinB[9] ^ dinA[12]&dinB[8];
  assign dout[8] = dinA[0]&dinB[8] ^ dinA[1]&dinB[7] ^ dinA[2]&dinB[6] ^ dinA[3]&dinB[5] ^ dinA[4]&dinB[4] ^ dinA[5]&dinB[3] ^ dinA[6]&dinB[2] ^ dinA[7]&dinB[1] ^ dinA[8]&dinB[0] ^ dinA[5]&dinB[12] ^ dinA[6]&dinB[11] ^ dinA[7]&dinB[10] ^ dinA[8]&dinB[9] ^ dinA[9]&dinB[8] ^ dinA[10]&dinB[7] ^ dinA[11]&dinB[6] ^ dinA[12]&dinB[5] ^ dinA[6]&dinB[12] ^ dinA[7]&dinB[11] ^ dinA[8]&dinB[10] ^ dinA[9]&dinB[9] ^ dinA[10]&dinB[8] ^ dinA[11]&dinB[7] ^ dinA[12]&dinB[6] ^ dinA[8]&dinB[12] ^ dinA[9]&dinB[11] ^ dinA[10]&dinB[10] ^ dinA[11]&dinB[9] ^ dinA[12]&dinB[8] ^ dinA[9]&dinB[12] ^ dinA[10]&dinB[11] ^ dinA[11]&dinB[10] ^ dinA[12]&dinB[9];
  assign dout[9] = dinA[0]&dinB[9] ^ dinA[1]&dinB[8] ^ dinA[2]&dinB[7] ^ dinA[3]&dinB[6] ^ dinA[4]&dinB[5] ^ dinA[5]&dinB[4] ^ dinA[6]&dinB[3] ^ dinA[7]&dinB[2] ^ dinA[8]&dinB[1] ^ dinA[9]&dinB[0] ^ dinA[6]&dinB[12] ^ dinA[7]&dinB[11] ^ dinA[8]&dinB[10] ^ dinA[9]&dinB[9] ^ dinA[10]&dinB[8] ^ dinA[11]&dinB[7] ^ dinA[12]&dinB[6] ^ dinA[7]&dinB[12] ^ dinA[8]&dinB[11] ^ dinA[9]&dinB[10] ^ dinA[10]&dinB[9] ^ dinA[11]&dinB[8] ^ dinA[12]&dinB[7] ^ dinA[9]&dinB[12] ^ dinA[10]&dinB[11] ^ dinA[11]&dinB[10] ^ dinA[12]&dinB[9] ^ dinA[10]&dinB[12] ^ dinA[11]&dinB[11] ^ dinA[12]&dinB[10];
  assign dout[10] = dinA[0]&dinB[10] ^ dinA[1]&dinB[9] ^ dinA[2]&dinB[8] ^ dinA[3]&dinB[7] ^ dinA[4]&dinB[6] ^ dinA[5]&dinB[5] ^ dinA[6]&dinB[4] ^ dinA[7]&dinB[3] ^ dinA[8]&dinB[2] ^ dinA[9]&dinB[1] ^ dinA[10]&dinB[0] ^ dinA[7]&dinB[12] ^ dinA[8]&dinB[11] ^ dinA[9]&dinB[10] ^ dinA[10]&dinB[9] ^ dinA[11]&dinB[8] ^ dinA[12]&dinB[7] ^ dinA[8]&dinB[12] ^ dinA[9]&dinB[11] ^ dinA[10]&dinB[10] ^ dinA[11]&dinB[9] ^ dinA[12]&dinB[8] ^ dinA[10]&dinB[12] ^ dinA[11]&dinB[11] ^ dinA[12]&dinB[10] ^ dinA[11]&dinB[12] ^ dinA[12]&dinB[11];
  assign dout[11] = dinA[12]&dinB[12] ^ dinA[0]&dinB[11] ^ dinA[1]&dinB[10] ^ dinA[2]&dinB[9] ^ dinA[3]&dinB[8] ^ dinA[4]&dinB[7] ^ dinA[5]&dinB[6] ^ dinA[6]&dinB[5] ^ dinA[7]&dinB[4] ^ dinA[8]&dinB[3] ^ dinA[9]&dinB[2] ^ dinA[10]&dinB[1] ^ dinA[11]&dinB[0] ^ dinA[8]&dinB[12] ^ dinA[9]&dinB[11] ^ dinA[10]&dinB[10] ^ dinA[11]&dinB[9] ^ dinA[12]&dinB[8] ^ dinA[9]&dinB[12] ^ dinA[10]&dinB[11] ^ dinA[11]&dinB[10] ^ dinA[12]&dinB[9] ^ dinA[11]&dinB[12] ^ dinA[12]&dinB[11];
  assign dout[12] = dinA[12]&dinB[12] ^ dinA[0]&dinB[12] ^ dinA[1]&dinB[11] ^ dinA[2]&dinB[10] ^ dinA[3]&dinB[9] ^ dinA[4]&dinB[8] ^ dinA[5]&dinB[7] ^ dinA[6]&dinB[6] ^ dinA[7]&dinB[5] ^ dinA[8]&dinB[4] ^ dinA[9]&dinB[3] ^ dinA[10]&dinB[2] ^ dinA[11]&dinB[1] ^ dinA[12]&dinB[0] ^ dinA[9]&dinB[12] ^ dinA[10]&dinB[11] ^ dinA[11]&dinB[10] ^ dinA[12]&dinB[9] ^ dinA[10]&dinB[12] ^ dinA[11]&dinB[11] ^ dinA[12]&dinB[10];

endmodule
