/*
 * Copyright (C) 2017
 * Authors: Wen Wang <wen.wang.ww349@yale.edu>
 *          Ruben Niederhagen <ruben@polycephaly.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
*/

//polynomial multiplication on two degree-118 polynomials

module poly_mul_reduced (
  input  wire		        start,
  input  wire 		      clk,
  input  wire [1546:0]  poly_g,
  input  wire [1546:0]  poly_f,
  output wire [1546:0]  poly_out,
  output wire 		      done
//  output wire          poly_mul_20_done
);

wire [3106:0] poly_R;
wire          poly_mul_done;

poly_mul_koa poly_mul_koa_inst (
  .clk(clk),
  .start(start),
  .poly_g({13'b0, poly_g}),
  .poly_f({13'b0, poly_f}),
  .poly_out(poly_R),
  .done(poly_mul_done)
);

poly_red koa_red_inst (
  .clk(clk),
  .start(poly_mul_done),
  .poly_in(poly_R[3080:0]),
  .poly_out(poly_out),
  .done(done)
);

endmodule

