/*
 * Copyright (C) 2017
 * Authors: Wen Wang <wen.wang.ww349@yale.edu>
 *          Ruben Niederhagen <ruben@polycephaly.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
*/

//vector multiplicaiton on GF(2^gf)
module vec_mul_reduction (
 
  input  wire	 		 clk,
  input  wire [415:0]    vec_a,
  input  wire [415:0]	 vec_b ,
  output wire  [415:0]    vec_c
   
);

wire [415:0] A;
wire [415:0] B;
wire [415:0] C;

assign A[12:0] = vec_a[12:0];
assign A[25:13] = vec_a[25:13];
assign A[38:26] = vec_a[38:26];
assign A[51:39] = vec_a[51:39];
assign A[64:52] = vec_a[64:52];
assign A[77:65] = vec_a[77:65];
assign A[90:78] = vec_a[90:78];
assign A[103:91] = vec_a[103:91];
assign A[116:104] = vec_a[116:104];
assign A[129:117] = vec_a[129:117];
assign A[142:130] = vec_a[142:130];
assign A[155:143] = vec_a[155:143];
assign A[168:156] = vec_a[168:156];
assign A[181:169] = vec_a[181:169];
assign A[194:182] = vec_a[194:182];
assign A[207:195] = vec_a[207:195];
assign A[220:208] = vec_a[220:208];
assign A[233:221] = vec_a[233:221];
assign A[246:234] = vec_a[246:234];
assign A[259:247] = vec_a[259:247];
assign A[272:260] = vec_a[272:260];
assign A[285:273] = vec_a[285:273];
assign A[298:286] = vec_a[298:286];
assign A[311:299] = vec_a[311:299];
assign A[324:312] = vec_a[324:312];
assign A[337:325] = vec_a[337:325];
assign A[350:338] = vec_a[350:338];
assign A[363:351] = vec_a[363:351];
assign A[376:364] = vec_a[376:364];
assign A[389:377] = vec_a[389:377];
assign A[402:390] = vec_a[402:390];
assign A[415:403] = vec_a[415:403];

assign B[12:0] = vec_b[12:0];
assign B[25:13] = vec_b[25:13];
assign B[38:26] = vec_b[38:26];
assign B[51:39] = vec_b[51:39];
assign B[64:52] = vec_b[64:52];
assign B[77:65] = vec_b[77:65];
assign B[90:78] = vec_b[90:78];
assign B[103:91] = vec_b[103:91];
assign B[116:104] = vec_b[116:104];
assign B[129:117] = vec_b[129:117];
assign B[142:130] = vec_b[142:130];
assign B[155:143] = vec_b[155:143];
assign B[168:156] = vec_b[168:156];
assign B[181:169] = vec_b[181:169];
assign B[194:182] = vec_b[194:182];
assign B[207:195] = vec_b[207:195];
assign B[220:208] = vec_b[220:208];
assign B[233:221] = vec_b[233:221];
assign B[246:234] = vec_b[246:234];
assign B[259:247] = vec_b[259:247];
assign B[272:260] = vec_b[272:260];
assign B[285:273] = vec_b[285:273];
assign B[298:286] = vec_b[298:286];
assign B[311:299] = vec_b[311:299];
assign B[324:312] = vec_b[324:312];
assign B[337:325] = vec_b[337:325];
assign B[350:338] = vec_b[350:338];
assign B[363:351] = vec_b[363:351];
assign B[376:364] = vec_b[376:364];
assign B[389:377] = vec_b[389:377];
assign B[402:390] = vec_b[402:390];
assign B[415:403] = vec_b[415:403];

assign vec_c[12:0] = C[12:0];
assign vec_c[25:13] = C[25:13];
assign vec_c[38:26] = C[38:26];
assign vec_c[51:39] = C[51:39];
assign vec_c[64:52] = C[64:52];
assign vec_c[77:65] = C[77:65];
assign vec_c[90:78] = C[90:78];
assign vec_c[103:91] = C[103:91];
assign vec_c[116:104] = C[116:104];
assign vec_c[129:117] = C[129:117];
assign vec_c[142:130] = C[142:130];
assign vec_c[155:143] = C[155:143];
assign vec_c[168:156] = C[168:156];
assign vec_c[181:169] = C[181:169];
assign vec_c[194:182] = C[194:182];
assign vec_c[207:195] = C[207:195];
assign vec_c[220:208] = C[220:208];
assign vec_c[233:221] = C[233:221];
assign vec_c[246:234] = C[246:234];
assign vec_c[259:247] = C[259:247];
assign vec_c[272:260] = C[272:260];
assign vec_c[285:273] = C[285:273];
assign vec_c[298:286] = C[298:286];
assign vec_c[311:299] = C[311:299];
assign vec_c[324:312] = C[324:312];
assign vec_c[337:325] = C[337:325];
assign vec_c[350:338] = C[350:338];
assign vec_c[363:351] = C[363:351];
assign vec_c[376:364] = C[376:364];
assign vec_c[389:377] = C[389:377];
assign vec_c[402:390] = C[402:390];
assign vec_c[415:403] = C[415:403];

gf_mul gf_mul_inst0 (
  .clk(clk),
  .dinA(A[12:0]),
  .dinB(B[12:0]),
  .dout(C[12:0])
);

gf_mul gf_mul_inst1 (
  .clk(clk),
  .dinA(A[25:13]),
  .dinB(B[25:13]),
  .dout(C[25:13])
);

gf_mul gf_mul_inst2 (
  .clk(clk),
  .dinA(A[38:26]),
  .dinB(B[38:26]),
  .dout(C[38:26])
);

gf_mul gf_mul_inst3 (
  .clk(clk),
  .dinA(A[51:39]),
  .dinB(B[51:39]),
  .dout(C[51:39])
);

gf_mul gf_mul_inst4 (
  .clk(clk),
  .dinA(A[64:52]),
  .dinB(B[64:52]),
  .dout(C[64:52])
);

gf_mul gf_mul_inst5 (
  .clk(clk),
  .dinA(A[77:65]),
  .dinB(B[77:65]),
  .dout(C[77:65])
);

gf_mul gf_mul_inst6 (
  .clk(clk),
  .dinA(A[90:78]),
  .dinB(B[90:78]),
  .dout(C[90:78])
);

gf_mul gf_mul_inst7 (
  .clk(clk),
  .dinA(A[103:91]),
  .dinB(B[103:91]),
  .dout(C[103:91])
);

gf_mul gf_mul_inst8 (
  .clk(clk),
  .dinA(A[116:104]),
  .dinB(B[116:104]),
  .dout(C[116:104])
);

gf_mul gf_mul_inst9 (
  .clk(clk),
  .dinA(A[129:117]),
  .dinB(B[129:117]),
  .dout(C[129:117])
);

gf_mul gf_mul_inst10 (
  .clk(clk),
  .dinA(A[142:130]),
  .dinB(B[142:130]),
  .dout(C[142:130])
);

gf_mul gf_mul_inst11 (
  .clk(clk),
  .dinA(A[155:143]),
  .dinB(B[155:143]),
  .dout(C[155:143])
);

gf_mul gf_mul_inst12 (
  .clk(clk),
  .dinA(A[168:156]),
  .dinB(B[168:156]),
  .dout(C[168:156])
);

gf_mul gf_mul_inst13 (
  .clk(clk),
  .dinA(A[181:169]),
  .dinB(B[181:169]),
  .dout(C[181:169])
);

gf_mul gf_mul_inst14 (
  .clk(clk),
  .dinA(A[194:182]),
  .dinB(B[194:182]),
  .dout(C[194:182])
);

gf_mul gf_mul_inst15 (
  .clk(clk),
  .dinA(A[207:195]),
  .dinB(B[207:195]),
  .dout(C[207:195])
);

gf_mul gf_mul_inst16 (
  .clk(clk),
  .dinA(A[220:208]),
  .dinB(B[220:208]),
  .dout(C[220:208])
);

gf_mul gf_mul_inst17 (
  .clk(clk),
  .dinA(A[233:221]),
  .dinB(B[233:221]),
  .dout(C[233:221])
);

gf_mul gf_mul_inst18 (
  .clk(clk),
  .dinA(A[246:234]),
  .dinB(B[246:234]),
  .dout(C[246:234])
);

gf_mul gf_mul_inst19 (
  .clk(clk),
  .dinA(A[259:247]),
  .dinB(B[259:247]),
  .dout(C[259:247])
);

gf_mul gf_mul_inst20 (
  .clk(clk),
  .dinA(A[272:260]),
  .dinB(B[272:260]),
  .dout(C[272:260])
);

gf_mul gf_mul_inst21 (
  .clk(clk),
  .dinA(A[285:273]),
  .dinB(B[285:273]),
  .dout(C[285:273])
);

gf_mul gf_mul_inst22 (
  .clk(clk),
  .dinA(A[298:286]),
  .dinB(B[298:286]),
  .dout(C[298:286])
);

gf_mul gf_mul_inst23 (
  .clk(clk),
  .dinA(A[311:299]),
  .dinB(B[311:299]),
  .dout(C[311:299])
);

gf_mul gf_mul_inst24 (
  .clk(clk),
  .dinA(A[324:312]),
  .dinB(B[324:312]),
  .dout(C[324:312])
);

gf_mul gf_mul_inst25 (
  .clk(clk),
  .dinA(A[337:325]),
  .dinB(B[337:325]),
  .dout(C[337:325])
);

gf_mul gf_mul_inst26 (
  .clk(clk),
  .dinA(A[350:338]),
  .dinB(B[350:338]),
  .dout(C[350:338])
);

gf_mul gf_mul_inst27 (
  .clk(clk),
  .dinA(A[363:351]),
  .dinB(B[363:351]),
  .dout(C[363:351])
);

gf_mul gf_mul_inst28 (
  .clk(clk),
  .dinA(A[376:364]),
  .dinB(B[376:364]),
  .dout(C[376:364])
);

gf_mul gf_mul_inst29 (
  .clk(clk),
  .dinA(A[389:377]),
  .dinB(B[389:377]),
  .dout(C[389:377])
);

gf_mul gf_mul_inst30 (
  .clk(clk),
  .dinA(A[402:390]),
  .dinB(B[402:390]),
  .dout(C[402:390])
);

gf_mul gf_mul_inst31 (
  .clk(clk),
  .dinA(A[415:403]),
  .dinB(B[415:403]),
  .dout(C[415:403])
);

endmodule

