/*
 * Copyright (C) 2017
 * Authors: Wen Wang <wen.wang.ww349@yale.edu>
 *          Ruben Niederhagen <ruben@polycephaly.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
*/

//vector multiplicaiton on GF(2^gf)
module vec_mul_twist (
 
  input  wire	 		 clk,
  input  wire [25:0]    vec_a,
  input  wire [25:0]	 vec_b ,
  output wire  [25:0]    vec_c
   
);

wire [25:0] A;
wire [25:0] B;
wire [25:0] C;

assign A[12:0] = vec_a[12:0];
assign A[25:13] = vec_a[25:13];

assign B[12:0] = vec_b[12:0];
assign B[25:13] = vec_b[25:13];

assign vec_c[12:0] = C[12:0];
assign vec_c[25:13] = C[25:13];

gf_mul gf_mul_inst0 (
  .clk(clk),
  .dinA(A[12:0]),
  .dinB(B[12:0]),
  .dout(C[12:0])
);

gf_mul gf_mul_inst1 (
  .clk(clk),
  .dinA(A[25:13]),
  .dinB(B[25:13]),
  .dout(C[25:13])
);

endmodule

